/* Copyright (c) 1999-2001 TTK Ciar / Bill Moyer
 * All rights reserved.                               
 *
 * This code is derived from code developed by TTK Ciar and Bill Moyer.    
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions         
 * are met:                                                                  
 *
 *  1. Redistributions of source code must retain the above copyright        
 *     notice, this list of conditions and the following disclaimer.
 *  2. The name of the author may not be used to endorse or promote
 *     products derived from this software without specific prior
 *     written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
// TTK here -- Clarification on above: This license is NOT viral and
// does NOT put you under any obligation to do ANY of the following:
//   ** distribute sources
//   ** contribute modifications
//   ** grant credit or show recognition
//   ** grant any other kind of compensation
// This document may be used and modified for free OR COMMERCIAL 
// development with impunity.  The SOLE intention of this license is 
// to prevent anyone from laying private claim to publicly available 
// versions of the source code and putting any kind of restrictions 
// on its distribution or use.

#ifndef _MISCLIB_H_
#define _MISCLIB_H_

#define  MISCLIB_VERSION   (0x0101)  // MSB is major revision, so this is v1.1

typedef void *(*alloc_ft)(unsigned int);
typedef void *(*free_ft)(void*);
typedef void *(*sm_ft)(void);

#ifndef _MISCLIB_C_
extern alloc_ft memalloc;
extern free_ft  memfree;
extern sm_ft    panic1;  // called iff had to free reserve to get memory
extern sm_ft    panic2;  // called iff freed reserve and still no memory
extern sm_ft    panic3;  // called iff no memory and no reserve allocated
extern int      smalloc_error;
#endif

#ifndef SMALLOC_DEFAULT_RESERVE_SIZE
#define SMALLOC_DEFAULT_RESERVE_SIZE  (0x100000) // 1MB reserve buffer
#endif

int smalloc_init ( int res_sz, sm_ft *panicf1, sm_ft *panicf2, sm_ft *panicf3 );
void *smalloc ( unsigned int n );

char *padstr ( char *str, char pad, int w, char *buf ) ;
char *padnum ( int num, int w, char *buf );
char *padhex ( int num, int w, int ucase, char *buf );

char *strndup( char *p, int limit );
char *memdup ( void *p, int n );
void scrub_free ( char *p, int k );
void scrub_free_str ( char *p );

// fdpoll() returns the number of bytes ready to be read from a file. 
int fdpoll ( int fd );

#endif

